<?php

namespace Modules\Coupon\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Coupon\Enums\DiscountStatusEnum;
use Modules\User\Enums\UserRoleEnum;

class SelllerRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::admins();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('sellers'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $statuses = DiscountStatusEnum::values();
        $rules =
            [
                'user_id'=>
                [
                    'required',
                    Rule::exists('users','id')->where('role',UserRoleEnum::SELLER->value)->whereNull('deleted_at')
                ],
                'code'=>
                    [
                        'required',
                        'string',
                        Rule::unique('coupons','code')->ignore($this->coupon->id ?? null)
                    ],
                'status_discount'=>
                    [
                        'required',
                        'in:'.implode(',',$statuses)
                    ],
                'discount'=>
                    [
                        'required',
                        'numeric',
                        'min:0',
                        (request('status_discount') == DiscountStatusEnum::PERCENTAGE->value ? 'max:100' : '')
                    ],
                'start_date'=>
                    [
                        'required',
                        'date'
                    ],
                'end_date'=>
                    [
                        'required',
                        'date',
                        'after_or_equal:start_date'
                    ],
                'count'=>
                    [
                        'required',
                        'numeric',
                        'min:0'
                    ],
                'user_count'=>
                    [
                        'required',
                        'numeric',
                        'min:1'
                    ]
            ];

        foreach (languages() as $lang)
        {
            $lang_rules=[
                'title_'.$lang->local=> 'required|max:150',
            ];
            $rules= array_merge($rules, $lang_rules);
        }


        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'user_id'=>__('coupons.user_id'),
            'code'=>__('coupons.code'),
            'status_discount'=>__('coupons.status_discount'),
            'discount'=>__('coupons.discount'),
            'start_date'=>__('coupons.start_date'),
            'end_date'=>__('coupons.end_date'),
            'count'=>__('coupons.count'),
            'user_count'=>__('coupons.user_count'),
            'user_id'=>__('coupons.user_id'),
        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => __('coupons.title').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
